Description

After update to 1.4.0 I can no longer filter host lists based on classes. Regardless of which class i try to filter with, theforeman returns

all hosts as a result.

Example of query:

/hosts?search=class=cacti

should return one host but returns all hosts.

Associated revisions

Revision a44dd094 - 03/13/2014 11:21 AM - Dominic Cleal

fixes #4314 - ignore default scope ordering on host search by puppet class

Revision f96d1ded - 03/17/2014 01:48 PM - Dominic Cleal

fixes #4314 - ignore default scope ordering on host search by puppet class

(cherry picked from commit a44dd0943b5ccc2c2e9a0ce264e4b2f38b5edd4d)

Conflicts:

app/models/concerns/hostext/search.rb

History

#1 - 02/14/2014 12:26 PM - Dominic Cleal

- Project changed from Hammer CLI to Foreman

- Category changed from Foreman commands (obsolete) to Search

#2 - 02/16/2014 12:59 PM - Adam Winberg

Got this from production.log in debug mode:

Hostgroup Load (0.6ms)  SELECT DISTINCT hostgroups.id FROM "hostgroups" INNER JOIN "hostgroup_classes" ON "hos

tgroup_classes"."hostgroup_id" = "hostgroups"."id" INNER JOIN "puppetclasses" ON "puppetclasses"."id" = "hostg

roup_classes"."puppetclass_id" WHERE (puppetclasses.name = 'foreman') ORDER BY hostgroups.label

PGError: ERROR:  for SELECT DISTINCT, ORDER BY expressions must appear in select list

LINE 1: ..." WHERE (puppetclasses.name = 'foreman') ORDER BY hostgroups...

 The PGError indicates there is something wrong with the query. Adjusting the query to include 'hostgroups.label' in the SELECT gets rid of this error,

dont know where in the source this is set though.

#3 - 02/27/2014 09:17 AM - Adam Winberg

changing row 34 in app/models/hostgroup.rb from

order("hostgroups.label")

 to 
order("hostgroups.id")

 fixes the problem. But does it introduce other problems?

#4 - 02/27/2014 10:09 AM - Dominic Cleal

It'd mean the sorting of the host groups in the main list is by their numerical IDs rather than their names.  We changed to this a while ago in #3107 for

improved usability.

#5 - 03/12/2014 10:25 AM - Dominic Cleal

- Status changed from New to Assigned

- Assignee set to Dominic Cleal

- Target version set to 1.9.0

- translation missing: en.field_release set to 7

#6 - 03/12/2014 10:29 AM - Dominic Cleal

- Status changed from Assigned to Ready For Testing

https://github.com/theforeman/foreman/pull/1292

#7 - 03/13/2014 11:31 AM - Dominic Cleal

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset a44dd0943b5ccc2c2e9a0ce264e4b2f38b5edd4d.
